class Admin::PersonalPluginFieldsController < OrbitAdminController
  	require 'fileutils'
  	include Admin::PersonalPluginFieldsHelper
	  before_action :set_personal_plugin_field, only: [:show, :edit , :update, :destroy, :fields_setting, :update_fields_setting,:generate_plugin]

	def index
    	@personal_plugin_fields = PersonalPluginField.order_by(:created_at=>'desc').page(params[:page]).per(10)
	end

	def new
		@member = MemberProfile.find_by(:uid=>params['uid']) rescue nil
    	@personal_plugin_field = PersonalPluginField.new
	end

	def create
		personal_plugin_field = PersonalPluginField.create(personal_plugin_field_params)
		redirect_to params[:referer_url]
	end

	def edit
	end

	def destroy
		@personal_plugin_field.destroy
		redirect_to admin_personal_plugin_fields_path(:page => params[:page])
	end

	def update
		@personal_plugin_field.update_attributes(personal_plugin_field_params)
		@personal_plugin_field.save
		redirect_to params[:referer_url]
	end
	def fields_setting
	end
	def update_fields_setting
		field_params = params.require(:personal_plugin_field).permit! rescue {}
		@personal_plugin_field.update_attributes(field_params)
		@personal_plugin_field.save
		redirect_to params[:referer_url]
	end
	def generate_plugin
		template_dir_path = File.expand_path("../../../../template_generator/", __FILE__) + "/"
		cp_template_dir_path = "#{Rails.root}/tmp/#{@personal_plugin_field.module_name}/"
		FileUtils.rm_rf(cp_template_dir_path)
		FileUtils.cp_r(template_dir_path,cp_template_dir_path)
		dirs = Dir.glob("#{cp_template_dir_path}*/")
		files = Dir.glob("#{cp_template_dir_path}*").select { |fn| File.file?(fn) }
		begin
		in_use_locales = Site.first.in_use_locales
		primary_modal_fields = @personal_plugin_field.primary_modal_fields.select{|f| (f[:field_name].present? rescue false)}
		yml_files = Dir.glob("#{cp_template_dir_path}config/locales/*.yml")
		yml_files.each do |yml_file|
			locale = yml_file.split("/").last.split(".yml").first
			yml_text = File.read(yml_file)
			translate_hash = {}
			primary_modal_fields.each do |field_value|
				if (field_value[:translation_name][locale].present? rescue false)
					translate_hash[field_value[:field_name]] = field_value[:translation_name][locale]
				end
			end
			@personal_plugin_field.related_modal_name.each_with_index do |related_modal_name,i|
				field_values = @personal_plugin_field.related_modal_fields[i].to_a rescue []
				sub_hash = {}
				field_values.each do |field_value|
					if field_value[:field_name] && (field_value[:translation_name][locale].present? rescue false)
						sub_hash[field_value[:field_name]] = field_value[:translation_name][locale]
					end
				end
				if related_modal_name.present? && sub_hash.present?
					translate_hash[related_modal_name] = sub_hash
				end
				#sub_hash["modal_name"] =  "關聯欄位翻譯"
			end
			author_name_translation = @personal_plugin_field.author_name_translations[locale] rescue ""
			I18n.with_locale(locale) do
				author_name_translation = I18n.t("personal_plugins.author") if author_name_translation.blank?
			end
			translate_hash["author_name_translation"] = author_name_translation
			col_name_translate_yaml = ""
			if translate_hash.present?
				col_name_translate_yaml = translate_hash.to_yaml.gsub("---\n", '')
			end
			yml_text = gsub_text_by_key_value(yml_text,"col_name_translate_yaml",col_name_translate_yaml)
			yml_text = yml_text.gsub("personal_plugin_template_translate",@personal_plugin_field.title_translations[locale])
			File.open(yml_file,'w+') do |f|
				f.write(yml_text)
			end
		end
		@blank_text = "    "
		slug_title = primary_modal_fields.select{|field_value| field_value[:slug_title] == "1" rescue false}.first[:field_name].to_s rescue ""
		plugin_template_related_files = primary_modal_fields.select{|field_value| field_value[:field_type] == "file" rescue false}.map{|v| v[:field_name]}
		plugin_template_related_links = primary_modal_fields.select{|field_value| field_value[:field_type] == "link" rescue false}.map{|v| v[:field_name]}
		plugin_template_related_members = primary_modal_fields.select{|field_value| field_value[:field_type] == "member" rescue false}.map{|v| v[:field_name]}
		plugin_template_related_files_text = plugin_template_related_files.to_s
		plugin_template_related_links_text = plugin_template_related_links.to_s
		fields = plugin_template_related_files + plugin_template_related_links
		plugin_template_related_files_fields = fields.map{|field_name|
			"has_many :#{field_name.pluralize}, :dependent => :destroy, :autosave => true\r\n" +
			"accepts_nested_attributes_for :#{field_name.pluralize}, :allow_destroy => true"
		}.join("\r\n")
		plugin_template = @personal_plugin_field.primary_modal_name
		backend_index_fields = @personal_plugin_field.backend_fields["index"] rescue []
		backend_index_fields_contents = backend_index_fields.map do |field_name|
			if field_name == slug_title
				"\r\n		<%= link_to #{plugin_template}.#{field_name}, page_for_#{plugin_template}(#{plugin_template}), target: \"blank\" %>\r\n" + 
				"			<div class=\"quick-edit\">\r\n"+
				"				<ul class=\"nav nav-pills hide\">\r\n"+
				"					<li><%= link_to t('edit'), edit_admin_#{plugin_template}_path(#{plugin_template},:page => params[:page]) %></li>\r\n"+
				"					<li><%= link_to t(:delete_), admin_#{plugin_template}_path(id: #{plugin_template}.id, :page => params[:page]), method: :delete, data: { confirm: 'Are you sure?' } %></li>\r\n"+
				"				</ul>\r\n"+
				"			</div>\r\n		"
			elsif field_name.include?(".")
				"<%= #{plugin_template}.#{field_name} rescue \"\" %>"
			elsif fields.include?(field_name) || plugin_template_related_members.include?(field_name) #file or link or member
				"<%= #{plugin_template}.display_field(\"#{field_name}\").html_safe rescue \"\" %>"
			else
				"<%= #{plugin_template}.#{field_name} %>"
			end
		end
		col_name_to_show = @personal_plugin_field.frontend_fields["member_show"] rescue []
		col_name_to_show_in_show_page = @personal_plugin_field.frontend_fields["show"] rescue []
		col_name_to_show_in_index_page = @personal_plugin_field.frontend_fields["index"] rescue []
		extra_translate_title = col_name_to_show_in_index_page.map{|field_name|  #在個人外掛前台index頁面的欄位翻譯名稱hash
			["th-#{field_name}","I18n.t(\"#{@personal_plugin_field.module_name}.#{field_name}\")"]
		}
		col_fields = get_fields_text(primary_modal_fields)
		col_related_fields = @personal_plugin_field.related_modal_fields.map{|field_values| get_fields_text(field_values)}
		plugin_template_related = @personal_plugin_field.related_modal_name.select{|n| n.present?}
		plugin_template_related_main_field = @personal_plugin_field.related_modal_fields.map{|field_values|
			slug_titles = field_values.select{|field_value| (field_value[:slug_title] == "1" rescue false)}
			if slug_titles.count == 0
				slug_titles = field_values
			end
			slug_titles.map{|field_value| field_value[:field_name]}.select{|t| t.present?}.first 
		}
		locale_fields , none_locale_fields , locale_fields_input_fields,none_locale_fields_input_fields = get_input_fields(primary_modal_fields)
		related_locale_fields = []
		related_none_locale_fields = []
		related_locale_fields_input_fields = []
		related_none_locale_fields_input_fields = []
		@personal_plugin_field.related_modal_fields.each_with_index do |field_values,i|
			related_modal_name =  @personal_plugin_field.related_modal_name[i]
			f1 , f2 , f3 , f4 = get_input_fields(field_values,related_modal_name,related_modal_name)
			related_locale_fields << f1
			related_none_locale_fields << f2
			related_locale_fields_input_fields << f3
			related_none_locale_fields_input_fields << f4
		end
		backend_profile_fields = backend_index_fields
		backend_profile_fields_contents = backend_index_fields_contents
		datetime_field_types_hash = {"year_month"=>"%Y/%m","date"=>"%Y/%m/%d","time"=>"%H:%M","date_time"=>"%Y/%m/%d %H:%M"}
		datetime_fields = primary_modal_fields.select{|field_value| datetime_field_types_hash.keys.include?(field_value[:field_type])}.map{|field_value| 
			[field_value[:field_name],datetime_field_types_hash[field_value[:field_type]]]
		}.to_h
		value_case_codes = ["value = #{plugin_template}.send(field) rescue \"\"",
						"if field.include?(\".\")",
						"#{@blank_text}value = #{plugin_template}",
						"#{@blank_text}field.split(\".\").each{|f| value = value.send(f) rescue nil }",
						"end",
						"file_fields = #{plugin_template_related_files}",
						"link_fields = #{plugin_template_related_links}",
						"member_fields = #{plugin_template_related_members}",
						"if file_fields.include?(field)",
						"#{@blank_text}files = #{plugin_template}.send(field.pluralize)",
						"#{@blank_text}value = files.map do |file|",
						"#{@blank_text * 2}url = file.file.url",
						"#{@blank_text * 2}title = (file.title.blank? ? File.basename(file.file.path) : file.title)",
						"#{@blank_text * 2}\"<li><a href='\#{url}'' target='_blank'>\#{title}</li>\"",
						"#{@blank_text}end",
						"#{@blank_text}value = value.join(\"\")",
						"elsif link_fields.include?(field)",
						"#{@blank_text}links = #{plugin_template}.send(field.pluralize)",
						"#{@blank_text}value = links.map do |link|",
						"#{@blank_text * 2}url = link.url",
						"#{@blank_text * 2}title = (link.title.blank? ? url : link.title)",
						"#{@blank_text * 2}\"<li><a href='\#{url}'' target='_blank'>\#{title}</li>\"",
						"#{@blank_text}end",
						"#{@blank_text}value = value.join(\"\")",
						"elsif member_fields.include?(field)",
						"#{@blank_text}members = #{plugin_template}.send(field.pluralize)",
						"#{@blank_text}value = members.map{|m|",
						"#{@blank_text*2}path = OrbitHelper.url_to_plugin_show(m.to_param, 'member') rescue '#'",
      					"#{@blank_text*2}((text_only rescue false) ? m.name : \"<a href='\#{path}'>\#{m.name}</a>\")",
						"#{@blank_text}}",
						"#{@blank_text}join_text = (text_only rescue false) ? \",\" : \"<br>\"",
						"#{@blank_text}value = value.join(join_text)",
						"end",
						"strftime_hash = #{datetime_fields}",
						"if strftime_hash.keys.include?(field)",
						"#{@blank_text}value = value.strftime(strftime_hash[field]) rescue value",
						"end"
					].join("\r\n")
		display_field_code = value_case_codes + "\r\n" +
						"value = \"<a href='\#{OrbitHelper.url_to_plugin_show(#{plugin_template}.to_param,'#{@personal_plugin_field.module_name}')}' target='_blank'>\#{value}</a>\" if field == \"#{slug_title}\"\r\n" +
						"value"
		value_case_codes += "\r\nvalue"
		related_backend_index_fields = @personal_plugin_field.related_modal_fields.map{|field_values| 
			field_values.map{|field_value| (field_value[:field_name] rescue nil)}.select{|t| t.present?}
		}
		related_backend_index_fields_contents = related_backend_index_fields.map.with_index{|field_names,i|
			related_modal_name = @personal_plugin_field.related_modal_name[i]
			field_names.map{|field_name| "<%= #{related_modal_name}.#{field_name} %>"}
		}
		member_methods_define = primary_modal_fields.select{|f| f[:field_type] == "member"}.map{|field_value|
			["def #{field_value[:field_name].pluralize}",
    		"    MemberProfile.find(self.#{field_value[:field_name].singularize}_ids) rescue []",
  			"end"]
  		}.flatten
  		analysis_field_name = @personal_plugin_field.backend_fields[:analysis][0] rescue ""
  		analysis_field_name = "year" if analysis_field_name.blank?
  		analysis_field_input_fields = ""
  		personal_plugin_template = @personal_plugin_field.module_name
  		iterate_step_text = "1.minute"
  		if analysis_field_name.present?
  			field_type = primary_modal_fields.select{|f| f[:field_name] == analysis_field_name}.first[:field_type] rescue "date_time"
			
			analysis_field_input_fields = ["start","end"].map{|f| 
				"<span><%=t(\"#{personal_plugin_template}.extend_translate.#{f}_#{field_type}\")%></span>" +
				generate_input_field(field_type,"#{analysis_field_name}_#{f}" ).gsub("<%= f.","<%= ").gsub(", :new_record => @#{plugin_template}.new_record?","")
			}.join("")
			if field_type == "date" || field_type == "date_time"
				iterate_step_text = "1.day"
			elsif field_type == "year"
				iterate_step_text = "1"
			end	
		end
		time_fields = primary_modal_fields.select{|f| f[:field_type] == "time"}.map{|f| f[:field_name]}
		before_save_codes = ""#time_fields.map{|f| "self.#{f} = parse_time(self.#{f}.strftime('%H:%M'))"}.join("\r\n")
		@match_pattern = {"personal_plugin_template" => personal_plugin_template,
			"plugin_template" => plugin_template,
			"plugin_template_related" => plugin_template_related,
			"plugin_template_related_files_fields" => plugin_template_related_files_fields,
			"col_name_to_show" => col_name_to_show.to_s, #在會員前台頁面的顯示欄位
			"col_name_to_show_in_show_page" => col_name_to_show_in_show_page.to_s, #在個人外掛前台show頁面的顯示欄位
			"col_name_to_show_in_index_page" => col_name_to_show_in_index_page.to_s, #在個人外掛前台index頁面的顯示欄位
			"extra_translate_title" => extra_translate_title.map{|k,v| "\"#{k}\" => #{v}"}.join(", ").prepend("{").concat("}"),
			"col_fields" => col_fields,
			"col_related_fields" => col_related_fields,
			"plugin_template_file" => plugin_template_related_files,
			"plugin_template_link" => plugin_template_related_links,
			"plugin_template_sort_hash" => "nil",
			"col_name_to_show_in_index_page_arr" => col_name_to_show_in_index_page,
			"related_backend_index_fields" => related_backend_index_fields,
			"related_backend_index_fields_contents" => related_backend_index_fields_contents,
			"backend_index_fields" => backend_index_fields,
			"backend_index_fields_contents" => backend_index_fields_contents,
			"plugin_template_related_links_text" => plugin_template_related_links_text,
			"plugin_template_related_files_text" => plugin_template_related_files_text,
			"locale_fields" => locale_fields,
			"none_locale_fields" => none_locale_fields,
			"none_locale_fields_input_fields" => none_locale_fields_input_fields,
			"locale_fields_input_fields" => locale_fields_input_fields,
			"related_locale_fields" => related_locale_fields,
			"related_none_locale_fields" => related_none_locale_fields,
			"related_none_locale_fields_input_fields" => related_none_locale_fields_input_fields,
			"related_locale_fields_input_fields" => related_locale_fields_input_fields,
			"plugin_template_related_main_field" => plugin_template_related_main_field,
			"backend_profile_fields" => backend_profile_fields,
			"backend_profile_fields_contents" => backend_profile_fields_contents,
			"value_case_codes" => value_case_codes,
			"display_field_code" => display_field_code,
			"member_methods_define" => member_methods_define,
			"analysis_field_name" => analysis_field_name,
			"analysis_field_input_fields" => analysis_field_input_fields,
			"before_save_codes" => before_save_codes,
			"time_fields_text" => time_fields.to_s,
			"iterate_step_text" => iterate_step_text
		}
		max_length = @match_pattern.keys.map{|k| k.length}.max
		@match_pattern = @match_pattern.sort_by{|k,v| (v.class != Array) ? (max_length - k.length) : -k.length}
		@logs = []
		replace_files(files)
		#Thread.new do
		replace_dirs(dirs,false)
		#end
		copy_templates("#{cp_template_dir_path}modules/#{@personal_plugin_field.module_name}/")
		render :html => @logs#@match_pattern#@logs.join("<br>").html_safe#@match_pattern
		rescue => e
			@match_pattern = {"parse_again_start"=>"","parse_again_end"=>"","col_name_translate_yaml"=>""} 
			replace_files(files)
			replace_dirs(dirs,false)
			render :html => e.backtrace.join("<br>")
		end
	end
	def copy_templates(source)
		templates = Dir.glob('app/templates/*/').select{|f| File.basename(f) != 'mobile'}
		templates.each do |template|
			FileUtils.cp_r(source,"#{template}modules/.")
		end
	end
	def get_input_fields(field_values,extra_field_name=nil,plugin_template = nil)
		none_locale_fields = []
		locale_fields = []
		locale_fields_input_fields = []
		none_locale_fields_input_fields = []
		@index = 0
		field_values.each do |field_value|
			field_name = field_value[:field_name]
			field_type = field_value[:field_type]
			next if field_name.blank?
			next if field_type == "file" || field_type == "link"
			if (field_value[:localize] == "1" rescue false)
				locale_fields << field_name
				input_field = generate_input_field(field_type,field_name,true,extra_field_name,plugin_template)
				locale_fields_input_fields << input_field
			else
				none_locale_fields << field_name
				input_field = generate_input_field(field_type,field_name,false,extra_field_name,plugin_template)
				none_locale_fields_input_fields << input_field
			end
			@index += 1
		end
		return locale_fields , none_locale_fields , locale_fields_input_fields,none_locale_fields_input_fields
	end
	def generate_input_field(field_type,field_name,localize = false,extra_field_name = nil, plugin_template = nil)
		personal_plugin_template = @personal_plugin_field.module_name
		plugin_template = @personal_plugin_field.primary_modal_name if plugin_template.nil?
		input_field = ""
		field_value_text = "@#{plugin_template}.#{field_name}"
		field_name_text = "\"#{field_name}\""
		field_name_text = "locale" if localize
		placeholder = "#{personal_plugin_template}.#{field_name}"
		placeholder = "#{personal_plugin_template}.#{extra_field_name}.#{field_name}" if extra_field_name
		if localize
			field_value_text = "@#{plugin_template}.#{field_name}_translations[locale]"
		end
		case field_type
		when "year"
			input_field = datetime_picker_text(plugin_template,field_name_text, "yyyy")#"<%= select_year((#{field_value_text} ? #{field_value_text}.to_i : DateTime.now.year), {:start_year => DateTime.now.year + 5, :end_year => 1930}, {:name => '#{plugin_template}[#{field_name}]',:class => 'span1'} ) %>"
		when "year_month"
			input_field = datetime_picker_text(plugin_template,field_name_text, "yyyy/MM")
		when "date"
			input_field = datetime_picker_text(plugin_template,field_name_text, "yyyy/MM/dd")
		when "time"
			input_field = datetime_picker_text(plugin_template,field_name_text, "HH:mm",true)
		when "date_time"
			input_field = datetime_picker_text(plugin_template,field_name_text)
		when "text_editor"
			input_field = "<%= f.text_area #{field_name_text}, class: \"input-block-level ckeditor\", placeholder: t(\"#{placeholder}\"), value: (#{field_value_text} rescue nil) %>"
		when "member"
			input_field = "<%= render partial: 'admin/member_selects/email_selection_box', locals: {field: '#{plugin_template}[#{field_name.singularize}_ids][]', email_members: @#{plugin_template}.#{field_name.pluralize},index:'#{@index}',select_name:'#{field_name.pluralize}'} %>"
		else #text_field
			input_field = "<%= f.text_field #{field_name_text}, class: \"input-block-level\", placeholder: t(\"#{placeholder}\"), value: (#{field_value_text} rescue nil) %>"
		end
		if localize
			input_field.prepend("<%= f.fields_for :#{field_name}_translations do |f| %>\r\n  ").concat("\r\n<% end %>")
		end
		input_field
	end
	def datetime_picker_text(plugin_template,field_name_text,format = "yyyy/MM/dd hh:mm",timepicker = false)
		extra_txt = ""
		extra_txt = ":picker_type => \"time\"," if timepicker
		"<%= f.datetime_picker #{field_name_text},:format => \"#{format}\",#{extra_txt} :no_label => true, :new_record => @#{plugin_template}.new_record? %>"
	end
	def get_fields_text(field_values)
		fields_text = field_values.map do |field_value|
			next if field_value[:field_type] == "file" || field_value[:field_type] == "link" || field_value[:field_name].blank?
			type = "String"
			default = "\"\""
			field_name = field_value[:field_name]
			case field_value[:field_type]
			when "year"
				type = "Integer"
				default = "DateTime.now.year"
			when "date"
				type = "Date"
				default = "Date.parse(DateTime.now.to_s)"
			when "time"
				type = "String"
				default = "\"\""
			when "date_time"
				type = "DateTime"
				default = "DateTime.now"
			when "year_month"
				type = "DateTime"
				default = "DateTime.now"
			when "member"
				type = "Array"
				default = "[]"
				field_name = "#{field_name.singularize}_ids"
			end
			no_localize_types = ["date","time","date_time","year_month"]
			field_text = "field :#{field_name}, :type => #{type}, :default => #{default}"
			field_text += ", :localize => true" if field_value[:localize] == "1" && !no_localize_types.include?(field_value[:field_type])
			field_text += ", as: :slug_title" if field_value[:slug_title] == "1"
			field_text
		end
		fields_text.select{|t| t.present?}.join("\r\n")
	end
	def replace_dirs(dirs,is_array = true)
		dirs.each_with_index do |dir,i|
			if is_array
				replace_dir(dir,i)
			else
				replace_dir(dir)
			end
		end
	end
	def replace_dir(dir,current_index = nil)
		dir = replace_file(dir,current_index)
		return true if dir.blank?
		if dir.class == Array
			replace_dirs(dir)
			return true
		end
		sub_dirs = Dir.glob("#{dir}/*/")
		files = Dir.glob("#{dir}/*").select { |fn| File.file?(fn) }
		@logs << files.to_s if current_index
		replace_files(files,current_index)
		if sub_dirs.present?
			sub_dirs.each do |sub_dir|
				replace_dir(sub_dir,current_index)
			end
		else
			return true
		end
	end
	def replace_files(files,current_index = nil)
		files.each do |file|
			replace_file(file,current_index)
		end
	end
	def replace_file(file,current_index = nil)
		isfile = File.file?(file)
		path = File.dirname(file)
		file_name = File.basename(file)
		new_filename = replace_text_with_pattern(file_name,true)
		if new_filename.blank?
			FileUtils.rm_rf("#{path}/#{file_name}")
		elsif file_name != new_filename
			if new_filename.class == Array
				new_filename.each do |f|
					next if f.blank?
					FileUtils.cp_r("#{path}/#{file_name}", "#{path}/#{f}")
				end
				FileUtils.rm_rf("#{path}/#{file_name}")
			else
				FileUtils.mv("#{path}/#{file_name}", "#{path}/#{new_filename}")
			end
		end
		if new_filename.blank?
			return ""
		else
			is_array = new_filename.class == Array
			if isfile
				files = Array(new_filename)
				files.each_with_index do |sub_file,i|
					next if File.extname(sub_file).match(/(png|jpg)/i)
					file_text = File.read("#{path}/#{sub_file}")
					if is_array
						file_text = replace_text_with_pattern(file_text,false,i,nil,true)
					elsif current_index
						@logs << sub_file
						file_text = replace_text_with_pattern(file_text,false,current_index,nil,true)
					else
						file_text = replace_text_with_pattern(file_text)
					end
					File.open("#{path}/#{sub_file}",'w+'){|f| f.write(file_text)}
				end
			end
			if is_array
				return new_filename.map{|sub_file| "#{path}/#{sub_file}" if sub_file.present?}.select{|f| f.present?}
			else
				return "#{path}/#{new_filename}"
			end
		end
	end
	def replace_text_with_pattern(text,is_file=false,i = nil,sub_i = nil,inner = false)
		new_text = text
		@match_pattern.each do |k,v|
			next if !include_key(new_text,k)
			vv = v
			vv = vv[i] if i && vv.class == Array
			vv = vv[sub_i] if sub_i && vv.class == Array
			if vv.class == String
				if i && vv == "" && is_file
					new_text = ""
				else
					new_text = gsub_text_by_key_value(new_text,k,vv)
				end
			elsif vv.class == Array
				if i
					@logs << i
				end
				if is_file
					if v.count == 0
						new_text = ""
						break
					else
						new_text = vv.map{|sub_v| gsub_text_by_key_value(new_text,k,sub_v)}
						break
					end
				end
				new_text = new_text.gsub(/parse_again_start((?:(?!parse_again_start).)+)parse_again_end/m) do |ff|
					parse_content = $1 #last match
					result = ff
					if include_key($1,k)
					  start_index = 0
					  end_index = parse_content.length
					  start_index = 2 if parse_content[0..1] == "\r\n"
					  end_index = end_index - 2 if parse_content[(end_index - 2)..(end_index - 1)] == "\r\n"
					  parse_content = parse_content.slice(start_index,end_index)
					  if inner
					  	result = (0...vv.count).map {|ii| replace_text_with_pattern(parse_content,false,i,ii,true) }.join("")
					  else
					  	result = (0...vv.count).map {|ii| replace_text_with_pattern(parse_content,false,ii) }.join("")
					  end
					end
					result
				end
			end
		end
		return new_text
	end
	def include_key(text,key)
		return text.include?(key) || text.include?(key.classify)
	end
	def gsub_text_by_key_value(text,k,v)
		@blank_texts = []
		text.gsub(/\n(\s*)[^\n]*(#{k}|#{k.classify})/m) {|ff|  @blank_texts << $1.gsub(/(\r\n|\n)/,'')}
		i = 0
		text = text.gsub(k + "s"){|ff| v.pluralize.gsub("\n","\n#{@blank_texts[i]}")}
		text = text.gsub(k ){|ff| v.gsub("\n","\n#{@blank_texts[i]}")}
		text = text.gsub(k.classify + "s"){|ff| v.classify.pluralize.gsub("\n","\n#{@blank_texts[i]}")}
		text = text.gsub(k.classify){|ff| v.classify.gsub("\n","\n#{@blank_texts[i]}")}
	end
	private
	def personal_plugin_field_params
		personal_plugin_field_params = params.require(:personal_plugin_field).permit! rescue {}
		if personal_plugin_field_params[:related_modal_name].nil?
			personal_plugin_field_params[:related_modal_name] = []
		end
		if personal_plugin_field_params[:primary_modal_fields]
			personal_plugin_field_params[:primary_modal_fields] = personal_plugin_field_params[:primary_modal_fields].values
		else
			personal_plugin_field_params[:primary_modal_fields] = []
		end
		if personal_plugin_field_params[:related_modal_fields]
			personal_plugin_field_params[:related_modal_fields] = personal_plugin_field_params[:related_modal_fields].values.map{|h| h.values}
		else
			personal_plugin_field_params[:related_modal_fields] = []
		end
		return personal_plugin_field_params
	end
	

	def set_personal_plugin_field
	    path = request.path.split('/')
	    if path.last.include? '-'
	      uid = path[-1].split("-").last
	      uid = uid.split("?").first
	    else
	      uid = path[-2].split("-").last
	      uid = uid.split("?").first
	    end
	     @personal_plugin_field = PersonalPluginField.find_by(:uid => uid) rescue PersonalPluginField.find(params[:id] || params[:personal_plugin_field_id])
	end
end