class Admin::PluginTemplatesController < OrbitMemberController
  	include Admin::PluginTemplatesHelper
	layout "member_plugin"
	before_action :set_plugin_template, only: [:show, :edit , :update, :destroy]
	before_action :set_plugin
	before_action :get_settings,:only => [:new, :edit, :setting]

	before_action :need_access_right
	before_action :allow_admin_only, :only => [:index, :setting]

	def index
    	@plugin_templates = PluginTemplate.order_by(:created_at=>'desc').page(params[:page]).per(10)
	end

	def new
		@member = MemberProfile.find_by(:uid=>params['uid']) rescue nil
    	@plugin_template = PluginTemplate.new
	end

	def create
		plugin_template = PluginTemplate.create(plugin_template_params)
		redirect_to params[:referer_url]
	end
	
	def show
	end
	def analysis
	end
	def analysis_report
	    role = params[:role_id]
	    analysis_field_name_start = params[:analysis_field_name_start]
	    analysis_field_name_end = params[:analysis_field_name_end]
	    graph_by = params[:graph_by]

	    @data = get_chart_data(analysis_field_name_start,analysis_field_name_end,role,params[:graph_by],params[:time_zone])

	    render :layout => false
	end
	
	def download_excel
	    analysis_field_name_start = params[:analysis_field_name_start]
	    analysis_field_name_end = params[:analysis_field_name_end]
	    @data = get_data_for_excel(analysis_field_name_start,analysis_field_name_end,params[:time_zone])
	    @protocol = (request.referer.blank? ? "http" : URI(request.referer).scheme)
   		@host_url = "#{@protocol}://#{request.host_with_port}"
	    respond_to do |format|
	      format.xlsx {
	        response.headers['Content-Disposition'] = 'attachment; filename="plugin_templates.xlsx"'
	      }
	    end
  	end

	def edit
	end

	def destroy
		@plugin_template.destroy
		redirect_to admin_plugin_templates_path(:page => params[:page])
	end

	def update
		@plugin_template.update_attributes(plugin_template_params)
		@plugin_template.save
		redirect_to params[:referer_url]
	end


	def setting
  	end

  	def frontend_setting
    	@member = MemberProfile.find_by(:uid=>params['uid']) rescue nil
    	@intro = PluginTemplateIntro.find_by(:member_profile_id=>@member.id) rescue nil
    	@intro = @intro.nil? ? PluginTemplateIntro.new({:member_profile_id=>@member.id}) : @intro
  	end

  	def update_frontend_setting
	    @member = MemberProfile.find(intro_params['member_profile_id']) rescue nil
	    @intro = PluginTemplateIntro.find_by(:member_profile_id=>@member.id) rescue nil
	    @intro = @intro.nil? ? PluginTemplateIntro.new({:member_profile_id=>@member.id}) : @intro
	    @intro.update_attributes(intro_params)
	    @intro.save
	    redirect_to URI.encode('/admin/members/'+@member.to_param+'/PluginTemplate')
  	end

  	def toggle_hide
  		if params[:ids]
	      @projects = PluginTemplate.any_in(_id: params[:ids])

	      @projects.each do |project|
	        project.is_hidden = params[:disable]
	        project.save
	      end
    	end

   		render json: {"success"=>true}
  	end

	private 

	def plugin_template_params
		params.require(:plugin_template).permit!
	end

	def intro_params
    	params.require(:plugin_template_intro).permit! rescue nil
  	end
	
	def get_settings
		parse_again_start
	    @plugin_template_relateds = PluginTemplateRelated.all
	    parse_again_end
	end

	def set_plugin
	    @plugin = OrbitApp::Plugin::Registration.all.select{|plugin| plugin.app_name.eql? 'PluginTemplate'}.first
	end

	def set_plugin_template
	    path = request.path.split('/')
	    if path.last.include? '-'
	      uid = path[-1].split("-").last
	      uid = uid.split("?").first
	    else
	      uid = path[-2].split("-").last
	      uid = uid.split("?").first
	    end
	    @plugin_template = PluginTemplate.find_by(:uid => uid) rescue PluginTemplate.find(params[:id])
	end
end